#!/usr/bin/env python3
import subprocess
import pyudev
import getpass
import socket
from gi.repository import GLib
from pydbus import SystemBus
import os
import time
import json
import ctypes
from ctypes import *

class kysec_devctl_info(Structure):
    _fields_ = [
        ('type', ctypes.c_int),
        ('usb_subtype', ctypes.c_int),
        ('pid', ctypes.c_uint),
        ('vid', ctypes.c_uint),
        ('perm', ctypes.c_int),
        ('oldperm', ctypes.c_int),
        ('serial', ctypes.c_char * 128),
        ('special_type', ctypes.c_int),
        ('displayname', ctypes.c_char * 256)
    ]

class kysec_devctl_blacklist(Structure):
    _fields_ = [
        ('name', ctypes.c_char * 128),
        ('type', ctypes.c_int)
    ]

loop = GLib.MainLoop()
bus2=SystemBus()
try:
    change = bus2.get("org.log.sys_transmit","/org/log/sys_transmit")
except Exception:
    print("log service is error")
asd, bsd = "", ""
def get_host_name():
    """获取当前用户名"""
    username = getpass.getuser()
    return  username

def get_host_time():
    """获取本机时间
    return: time_1
    """
    time_1=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
    return time_1

def get_host_ip():
    """
    查询本机ip地址
    :return: ip
    """
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.connect(('8.8.8.8', 80))
        ip = s.getsockname()[0]
    except Exception:
        return "127.0.0.1"
    return ip
class CDService(object):
    """
        <node>
            <interface name='com.kylin.CDControl'>
                <method name='GetStatus'>
                <arg type='i' name='status' direction='out'/>
                </method>
                <method name='SetStatus'>
                <arg type='i' name='status' direction='in'/>
                <arg type='i' name='ret' direction='out'/>
                </method>
            </interface>
        </node>
    """
    def __init__(self):
        self.so = ctypes.CDLL("libkysec_extend.so.0.0.0")

    def GetStatus(self):
        return 0
        count = c_int(0)
        self.so.kysec_devctl_read_all_dev_data.restype = POINTER(kysec_devctl_info)
        try:
            p = self.so.kysec_devctl_read_all_dev_data(byref(count))
            for i in range(0, count.value):
                if p[i].type == 5:
                    if p[i].perm == 1:
                        return 2
                    elif p[i].perm == 2:
                        return 0
                    else:
                        return 1
        except Exception:
            pass

        return 2

    def SetStatus(self, status):
        return 0
        if status == 0:
            # 设置管控
            count = c_int(0)
            self.so.kysec_devctl_read_all_dev_data.restype = POINTER(kysec_devctl_info)
            try:
                p = self.so.kysec_devctl_read_all_dev_data(byref(count))
                for i in range(0, count.value):
                    if p[i].type == 5:
                        if p[i].perm == 2:
                            return 0
            except Exception:
                pass

            str_1 = "'time':'{}','hostname':'{}','ip':'{}','name':'cd_control','lv':'info','message':'开启光驱管控模式'".format(get_host_time(), get_host_name(), get_host_ip())
            str_2 = '{' + str_1 + '}'
            try:
                change.log_transmit(str_2)
            except Exception:
                print("log service is error")

            policy = kysec_devctl_info()
            policy.type = 5           # KYSEC_CDROM
            policy.perm = 2           # DEVCTL_DISABLE
            '''
            DEVCTL_ENABLE  1
            DEVCTL_DISABLE 2
            DEVCTL_RO      5
            '''
            ret = self.so.kysec_devctl_add_perm(byref(policy))
            if ret != 0:
                ret = self.so.kysec_devctl_update_perm(byref(policy))
                if ret != 0:
                    return ret
            return 0

        elif status == 1:
            # 设置只读
            count = c_int(0)
            self.so.kysec_devctl_read_all_dev_data.restype = POINTER(kysec_devctl_info)
            try:
                p = self.so.kysec_devctl_read_all_dev_data(byref(count))
                for i in range(0, count.value):
                    if p[i].type == 5:
                        if p[i].perm == 5:
                            return 0
            except Exception:
                pass

            str_1 = "'time':'{}','hostname':'{}','ip':'{}','name':'cd_control','lv':'info','message':'开启光驱只读模式'".format(get_host_time(), get_host_name(), get_host_ip())
            str_2 = '{' + str_1 + '}'
            try:
                change.log_transmit(str_2)
            except Exception:
                print("log service is error")

            policy = kysec_devctl_info()
            policy.type = 5           # KYSEC_CDROM
            policy.perm = 5           # DEVCTL_RO
            '''
            DEVCTL_ENABLE  1
            DEVCTL_DISABLE 2
            DEVCTL_RO      5
            '''
            ret = self.so.kysec_devctl_add_perm(byref(policy))
            if ret != 0:
                ret = self.so.kysec_devctl_update_perm(byref(policy))
                if ret != 0:
                    return ret
            return 0

        elif status == 2:
            # 设置不管控
            count = c_int(0)
            self.so.kysec_devctl_read_all_dev_data.restype = POINTER(kysec_devctl_info)
            try:
                p = self.so.kysec_devctl_read_all_dev_data(byref(count))
                for i in range(0, count.value):
                    if p[i].type == 5:
                        if p[i].perm == 1:
                            return 0
            except Exception:
                pass

            str_1 = "'time':'{}','hostname':'{}','ip':'{}','name':'cd_control','lv':'info','message':'关闭光驱管控模式'".format(get_host_time(), get_host_name(), get_host_ip())
            str_2 = '{' + str_1 + '}'
            print(str_2)
            try:
                change.log_transmit(str_2)
            except Exception:
                print("log service is error")

            policy = kysec_devctl_info()
            policy.type = 5           # KYSEC_CDROM
            policy.perm = 1           # DEVCTL_ENABLE
            '''
            DEVCTL_ENABLE  1
            DEVCTL_DISABLE 2
            DEVCTL_RO      5
            '''
            ret = self.so.kysec_devctl_add_perm(byref(policy))
            if ret != 0:
                ret = self.so.kysec_devctl_update_perm(byref(policy))
                if ret != 0:
                    return ret
            return 0
        else:
            return -1

bus = SystemBus()
bus.publish("com.kylin.CDControl", CDService())
loop.run()

